package com.fp.persistence.parmas.soli;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMSOLICITUDREQUISITOS*/
@Entity(name="TarmSolicitudRequisitos")
@Table(name="TARMSOLICITUDREQUISITOS")
public class TarmSolicitudRequisitos extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmSolicitudRequisitos
*/
@EmbeddedId
private TarmSolicitudRequisitosKey pk;
@Column(name="CARGADO", nullable=true)

/**
* null
*/
private String cargado;

@Column(name="XPATHREQUISITO", nullable=true)

/**
* null
*/
private String xpathrequisito;

@Column(name="ESTADOVALIDACION", nullable=true)

/**
* null
*/
private String estadovalidacion;

/**Contructor por defecto*/
public TarmSolicitudRequisitos(){
}
/**Contructor de TarmSolicitudRequisitos
@param pPk Clave Primaria del entity
*/
public TarmSolicitudRequisitos(TarmSolicitudRequisitosKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmSolicitudRequisitos
*/
public static TarmSolicitudRequisitos find(EntityManager pEntityManager,TarmSolicitudRequisitosKey pKey) throws Exception{
    TarmSolicitudRequisitos obj = pEntityManager.find(TarmSolicitudRequisitos.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmSolicitudRequisitos
@return El objeto que referencia a la Clave primaria de TarmSolicitudRequisitos
*/
public TarmSolicitudRequisitosKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmSolicitudRequisitos
@param pPk El objeto que referencia a la nueva Clave primaria de TarmSolicitudRequisitos
*/
public void setPk(TarmSolicitudRequisitosKey pPk){
  pk=pPk;
}
/**Obtiene el valor de cargado
@return valor de cargado*/
public String getCargado(){
  return cargado;
}
/**Fija el valor de cargado
@param pCargado nuevo Valor de cargado*/
public void setCargado(String pCargado){
  cargado=pCargado;
}

/**Obtiene el valor de xpathrequisito
@return valor de xpathrequisito*/
public String getXpathrequisito(){
  return xpathrequisito;
}
/**Fija el valor de xpathrequisito
@param pXpathrequisito nuevo Valor de xpathrequisito*/
public void setXpathrequisito(String pXpathrequisito){
  xpathrequisito=pXpathrequisito;
}

/**Obtiene el valor de estadovalidacion
@return valor de estadovalidacion*/
public String getEstadovalidacion(){
  return estadovalidacion;
}
/**Fija el valor de estadovalidacion
@param pEstadovalidacion nuevo Valor de estadovalidacion*/
public void setEstadovalidacion(String pEstadovalidacion){
  estadovalidacion=pEstadovalidacion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmSolicitudRequisitos))return false;
    TarmSolicitudRequisitos that = (TarmSolicitudRequisitos) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmSolicitudRequisitos
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmSolicitudRequisitos
*/
public Object createInstance(){
 TarmSolicitudRequisitos instance=new TarmSolicitudRequisitos();	
 instance.setPk(new TarmSolicitudRequisitosKey());
 return instance;
}
/**Clona la entidad TarmSolicitudRequisitos
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmSolicitudRequisitos p=(TarmSolicitudRequisitos)this.clone();
  p.setPk((TarmSolicitudRequisitosKey)this.pk.cloneMe());
  return p;
}
}
